Product Competitors


This endpoint will provide you with a list of products that intersect with a target asin in Amazon SERPs. The data can help you identify product competitors for any listing published on Amazon. The returned results are specific to the asin as well as the location and language parameters specified in a POST request.

Learn more about ASIN in this help center article.

Data updates: data is updated weekly, the latest update time is available in the Status endpoint.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task. The maximum number of calls that can be sent simultaneously is limited to 30.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
asinstring

product ID
required field
unique product identifier (ASIN) on Amazon;
you can receive the asin parameter by making a separate request to the Amazon Products endpoint

location_namestring

full name of the location
required field if don't specify location_code
you can receive the list of available locations with their location_name by making a separate request to
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages;
Note: this endpoint currently supports the US, Egypt, Saudi Arabia, and the United Arab Emirates locations only;
example:
United States

location_codeinteger

location code
required field if don't specify location_name
you can receive the list of available locations with their location_code by making a separate request to
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages;
Note: this endpoint currently supports the US, Egypt, Saudi Arabia, and the United Arab Emirates locations only;
example:
2840

language_namestring

full name of the language
required field if don't specify language_code
you can receive the list of available languages with their language_name by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
example:
English

language_codestring

language code
required field if don't specify language_name
you can receive the list of available languages with their language_code by making a separate request to the
https://api.dataforseo.com/v3/dataforseo_labs/locations_and_languages
example:
en

limitinteger

the maximum number of products in the results array
optional field
default value: 100;
maximum value: 1000

filtersarray

array of results filtering parameters
optional field
you can add several filters at once (8 filters maximum)
you should set a logical operator and, or between the conditions
the following operators are supported:
regex, not_regex, <, <=, >, >=, =, <>, in, not_in, ilike, not_ilike, like, not_like, match, not_match
you can use the % operator with like and not_like, as well as ilike and not_ilike to match any string of zero or more characters
example:
["full_metrics.amazon_serp.pos_1",">", 20]

for more information about filters, please refer to Dataforseo Labs - Filters or this help center guide

order_byarray

results sorting rules
optional field
you can use the same values as in the filters array to sort the results
possible sorting types:
asc - results will be sorted in the ascending order
desc - results will be sorted in the descending order
you should use a comma to set up a sorting parameter
example:
["full_metrics.amazon_serp.pos_1,desc"]
note that you can set no more than three sorting rules in a single request
you should use a comma to separate several sorting rules
example:
["full_metrics.amazon_serp.pos_1,desc","avg_position,desc"]
default rule:
["ranked_serp_element.serp_item.rank_group,asc"]

offsetinteger

offset in the results array of returned product competitors
optional field
default value: 0
if you specify the 10 value, the first ten product competitors in the results array will be omitted and the data will be provided for the successive product competitors

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        se_typestring

search engine type

        asinstring

ASIN in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_null

        language_codestring

language code in a POST array
if there is no data, then the value is_null

        total_countinteger

total amount of results in our database relevant to your request

        items_countinteger

the number of results returned in the items array

        itemsarray

contains detected Amazon product competitors and related data

            se_typestring

search engine type

            asinstring

ASIN of the product
unique product identifier on Amazon;
for more information, refer to this help center guide

            avg_positionfloat

average position of the product in Amazon SERP
Note: average position is calculated for intersected keywords only;
the value for a given product may differ when combined with different target products

            sum_positioninteger

sum of all product positions in Amazon SERP
Note: average position is calculated for intersected keywords only;
the value for a given product may differ when combined with different target products

            intersectionsinteger

number of intersecting keywords

            competitor_metricsobject

metrics for intersecting keywords
ranking data relevant to the keywords that the provided asin shares with the target asin;
Note: in this object ranking data is provided for the returned competitor's asin

                amazon_serpobject

ranking data from Amazon organic SERP

                    pos_1integer

number of organic SERPs where the product ranks #1

                    pos_2_3integer

number of organic SERPs where the product ranks #2-3

                    pos_4_10integer

number of organic SERPs where the product ranks #4-10

                    pos_11_100integer

number of organic SERPs where the product ranks #11-100

                    countinteger

total count of Amazon organic SERPs that contain the product

                    search_volumeinteger

total search volume of the product's ranking keywords in organic SERP

                amazon_paidobject

ranking data from Amazon paid SERP

                    pos_1integer

number of paid SERPs where the product ranks #1

                    pos_2_3integer

number of paid SERPs where the product ranks #2-3

                    pos_4_10integer

number of paid SERPs where the product ranks #4-10

                    pos_11_100integer

number of paid SERPs where the product ranks #11-100

                    countinteger

total count of Amazon paid SERPs that contain the product

                    search_volumeinteger

total search volume of the product's ranking keywords in paid SERP

            full_metricsobject

metrics for all keywords of the product
full overview of ranking data relevant to all keywords that the provided asin is ranking for

                amazon_serpobject

ranking data from Amazon organic SERP

                    pos_1integer

number of organic SERPs where the product ranks #1

                    pos_2_3integer

number of organic SERPs where the product ranks #2-3

                    pos_4_10integer

number of organic SERPs where the product ranks #4-10

                    pos_11_100integer

number of organic SERPs where the product ranks #11-100

                    countinteger

total count of Amazon organic SERPs that contain the product

                    search_volumeinteger

total search volume of the product's ranking keywords in organic SERP

                amazon_paidobject

ranking data from Amazon paid SERP

                    pos_1integer

number of paid SERPs where the product ranks #1

                    pos_2_3integer

number of paid SERPs where the product ranks #2-3

                    pos_4_10integer

number of paid SERPs where the product ranks #4-10

                    pos_11_100integer

number of paid SERPs where the product ranks #11-100

                    countinteger

total count of Amazon paid SERPs that contain the product

                    search_volumeinteger

total search volume of the product's ranking keywords in paid SERP


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/dataforseo_labs/amazon/product_competitors/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "asin": "019005476X",
        "location_code": 2840,
        "language_code": "en"
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to set a task
$post_array[] = array(
   "asin" => "019005476X",
   "language_name" => "English",
   "location_code" => 2840
);
try {
   // POST /v3/dataforseo_labs/amazon/product_competitors/live
   $result = $client->post('/v3/dataforseo_labs/amazon/product_competitors/live', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "asin": "019005476X",
  "language_name": "English",
  "location_code": 2840
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/dataforseo_labs/amazon/product_competitors/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    asin="019005476X",
    location_name="United States",
    language_name="English"
)
# POST /v3/dataforseo_labs/amazon/product_competitors/live
response = client.post("/v3/dataforseo_labs/amazon/product_competitors/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task dataforseo_labs_amazon_product_competitors_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                asin = "019005476X",
                location_name = "United States",
                language_name = "English"
            });
            // POST /v3/dataforseo_labs/amazon/product_competitors/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/dataforseo_labs/amazon/product_competitors/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
    "version": "0.1.20220216",
    "status_code": 20000,
    "status_message": "Ok.",
    "time": "0.8135 sec.",
    "cost": 0.0105,
    "tasks_count": 1,
    "tasks_error": 0,
    "tasks": [
        {
            "id": "02221820-2806-0375-0000-66ac04dab3e3",
            "status_code": 20000,
            "status_message": "Ok.",
            "time": "0.6317 sec.",
            "cost": 0.0105,
            "result_count": 1,
            "path": [
                "v3",
                "dataforseo_labs",
                "amazon",
                "product_competitors",
                "live"
            ],
            "data": {
                "api": "dataforseo_labs",
                "function": "product_competitors",
                "se_type": "amazon",
                "asin": "019005476X",
                "language_name": "English",
                "location_code": 2840,
                "limit": 5
            },
            "result": [
                {
                    "se_type": "amazon",
                    "asin": "019005476X",
                    "location_code": 2840,
                    "language_code": "en",
                    "total_count": 104,
                    "items_count": 5,
                    "items": [
                        {
                            "se_type": "amazon",
                            "asin": "019005476X",
                            "avg_position": 15.5,
                            "sum_position": 62,
                            "intersections": 4,
                            "competitor_metrics": {
                                "amazon_serp": {
                                    "pos_1": 1,
                                    "pos_2_3": 0,
                                    "pos_4_10": 1,
                                    "pos_11_100": 2,
                                    "count": 4,
                                    "search_volume": 3100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            },
                            "full_metrics": {
                                "amazon_serp": {
                                    "pos_1": 1,
                                    "pos_2_3": 0,
                                    "pos_4_10": 1,
                                    "pos_11_100": 2,
                                    "count": 4,
                                    "search_volume": 3100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            }
                        },
                        {
                            "se_type": "amazon",
                            "asin": "0197543812",
                            "avg_position": 1,
                            "sum_position": 2,
                            "intersections": 2,
                            "competitor_metrics": {
                                "amazon_serp": {
                                    "pos_1": 2,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 2,
                                    "search_volume": 1100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            },
                            "full_metrics": {
                                "amazon_serp": {
                                    "pos_1": 2,
                                    "pos_2_3": 1,
                                    "pos_4_10": 0,
                                    "pos_11_100": 1,
                                    "count": 4,
                                    "search_volume": 1300
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            }
                        },
                        {
                            "se_type": "amazon",
                            "asin": "0192854259",
                            "avg_position": 6.5,
                            "sum_position": 13,
                            "intersections": 2,
                            "competitor_metrics": {
                                "amazon_serp": {
                                    "pos_1": 0,
                                    "pos_2_3": 1,
                                    "pos_4_10": 1,
                                    "pos_11_100": 0,
                                    "count": 2,
                                    "search_volume": 1100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            },
                            "full_metrics": {
                                "amazon_serp": {
                                    "pos_1": 1,
                                    "pos_2_3": 2,
                                    "pos_4_10": 2,
                                    "pos_11_100": 2,
                                    "count": 7,
                                    "search_volume": 1800
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            }
                        },
                        {
                            "se_type": "amazon",
                            "asin": "0895554690",
                            "avg_position": 5.5,
                            "sum_position": 11,
                            "intersections": 2,
                            "competitor_metrics": {
                                "amazon_serp": {
                                    "pos_1": 0,
                                    "pos_2_3": 1,
                                    "pos_4_10": 1,
                                    "pos_11_100": 0,
                                    "count": 2,
                                    "search_volume": 1100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            },
                            "full_metrics": {
                                "amazon_serp": {
                                    "pos_1": 0,
                                    "pos_2_3": 1,
                                    "pos_4_10": 1,
                                    "pos_11_100": 3,
                                    "count": 5,
                                    "search_volume": 1300
                                },
                                "amazon_paid": {
                                    "pos_1": 1,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 1,
                                    "search_volume": 600
                                }
                            }
                        },
                        {
                            "se_type": "amazon",
                            "asin": "0195052161",
                            "avg_position": 39.5,
                            "sum_position": 79,
                            "intersections": 2,
                            "competitor_metrics": {
                                "amazon_serp": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 2,
                                    "count": 2,
                                    "search_volume": 1100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            },
                            "full_metrics": {
                                "amazon_serp": {
                                    "pos_1": 1,
                                    "pos_2_3": 2,
                                    "pos_4_10": 1,
                                    "pos_11_100": 3,
                                    "count": 7,
                                    "search_volume": 2100
                                },
                                "amazon_paid": {
                                    "pos_1": 0,
                                    "pos_2_3": 0,
                                    "pos_4_10": 0,
                                    "pos_11_100": 0,
                                    "count": 0,
                                    "search_volume": 0
                                }
                            }
                        }
                    ]
                }
            ]
        }
    ]
}